#!/usr/bin/env python

import pygame
import sys
import math
import random

pygame.init()

startX = 300
startY = 750

fps = 20

mapXY= (600, 800)
screen = pygame.display.set_mode(mapXY)
pygame.display.set_caption('Tux Tower')


tux_img = pygame.image.load("images/tux.png")
bg = pygame.image.load("images/bg.png")
vagon = pygame.image.load("images/vagon.png")
fish = pygame.image.load("images/fish.png")

intro = pygame.image.load("images/intro.png")
outro = pygame.image.load("images/outro.png")

icon = pygame.image.load("images/icon.png")
pygame.display.set_icon(icon)


class Penguin:

    def __init__(self, pos, img):
        self.pos = pos
        self.img = img

    def draw(self):
        screen.blit(self.img, self.pos)
     
penguins = []

tux = Penguin([startX,startY], vagon)

penguins.append(tux)

watch = pygame.time.Clock()

tux = Penguin([penguins[-1].pos[0],startY-38*len(penguins)], tux_img)
penguins.append(tux)
tux = Penguin([penguins[-1].pos[0],startY-38*len(penguins)], tux_img)
penguins.append(tux)

acc = 0
time = 0
time2 = 0
time3 = 0
done = 0

screen.blit(intro, (0, 0))
pygame.display.flip()

while 1:
    
    watch.tick(fps)
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            sys.exit()
    keys = pygame.key.get_pressed()
    if keys[pygame.K_ESCAPE]:
        sys.exit()
    elif event.type == pygame.KEYDOWN:
        break

while done == 0:
    
    watch.tick(fps)
    time += 1
    time3 += 1
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            sys.exit()
    keys = pygame.key.get_pressed()
    if keys[pygame.K_ESCAPE]:
        sys.exit()

    if time > 60:
        if len(penguins) < 21:
            tux = Penguin([penguins[-1].pos[0],startY-38*len(penguins)], tux_img)
            penguins.append(tux)
            time = 0

    if keys[pygame.K_LEFT]:
        acc -= 1
        
    if keys[pygame.K_RIGHT]:
        acc += 1
        
    if acc > 20:
        acc = 20

    penguins[0].pos[0] += acc

    if penguins[0].pos[0] < 0:
        penguins[0].pos[0] = 0
    if penguins[0].pos[0] > 560:
        penguins[0].pos[0] = 560

    if len(penguins) == 2:
        penguins[-1].pos[0] = penguins[0].pos[0]

    # wind
    if len(penguins) > 2:
        wind = random.randrange(-2*len(penguins),2*len(penguins)+1)
        penguins[-1].pos[0] += wind
        if penguins[-1].pos[0] < 0:
            penguins[-1].pos[0] = 0
        elif penguins[-1].pos[0] > 570:
            penguins[-1].pos[0] = 570

    # move all penguins
    leng = len(penguins)

    if leng > 2:
        index = -2
        while penguins[index] != penguins[0]:         
            
            penguins[index].pos[0] -= (penguins[index].pos[0] - penguins[index+1].pos[0])/3

            index -= 1

    # check fall
    if len(penguins) > 2:
        if abs((penguins[0].pos[0]+20) - (penguins[1].pos[0]+15)) > 34:
            time2 += 1

        if time2 > 6:
            del penguins[-1]
            time2 = 0
                     

    # check win
    if len(penguins) > 20:
        if 260 < penguins[20].pos[0] < 310:
            done = 1 


    penguins[0].draw()

    for one in penguins[1:-1]:
        one.draw()


    rot = pygame.transform.rotate(fish, random.randrange(-15,16))
    obrRect = rot.get_rect()
    obrRect.centerx = 285 + random.randrange(-4,5) 
    obrRect.centery = 30 + random.randrange(-5,6)
    screen.blit(rot, obrRect)



    screen.blit(bg, (0,780))
    
    pygame.display.flip()
    screen.fill((90, 90, 115))

screen.blit(outro, (0,0))
total = unicode(str(time3/10), 'iso8859-2')	
color = (250, 0, 0)
fontik = pygame.font.Font(None, 100)
text = fontik.render(total, 1, color)

screen.blit(text, (275, 530))
pygame.display.flip()

while 1:
    
    watch.tick(fps)
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            sys.exit()
    keys = pygame.key.get_pressed()
    if keys[pygame.K_ESCAPE]:
        sys.exit()

